<template>
  <div class="relative w-full">
    <div id="theChart" class="the-chart"></div>
    <img width="56" height="8" src="@/assets/images/flash-logotype.svg" class="absolute left-3 bottom-12 " />
  </div>
</template>

<script>
import * as am4core from '@amcharts/amcharts4/core';
import * as am4charts from '@amcharts/amcharts4/charts';
import am4themes_animated from '@amcharts/amcharts4/themes/animated';

import randomData from '@/utils/randomData';
import zeroData from '@/utils/zeroData';

export default {
  name: 'TheChart',

  data() {
    return {
      randomData,
      zeroData,
      chart: null,

      gridLinesCount: 4,
    };
  },

  computed: {
    isAuthorized() {
      return this.$store.state.auth.isAuthorized;
    },
  },

  watch: {
    isAuthorized() {
      this.changeData();
    },
  },

  mounted() {
    this.initChart('theChart', this.zeroData);
  },

  methods: {
    changeData() {
      this.chart.dispose();
      this.initChart('theChart', this.randomData);
    },

    initChart(id, data) {
      am4core.useTheme(am4themes_animated);
      const chart = am4core.create(id, am4charts.XYChart);
      this.chart = chart;

      chart.paddingLeft = 0;
      chart.paddingRight = 0;
      chart.paddingTop = 2;
      chart.paddingBottom = 0;
      chart.background.fill = am4core.color('#111E2F');

      chart.numberFormatter.numberFormat = '####';
      chart.dateFormatter.dateFormat = 'dd MMM';

      const dateAxis = chart.xAxes.push(new am4charts.DateAxis());
      dateAxis.renderer.labels.template.fill = am4core.color('#405069');
      dateAxis.renderer.labels.template.fontSize = 12;
      dateAxis.renderer.labels.template.fontWeight = 600;
      dateAxis.renderer.labels.template.paddingTop = 11;
      dateAxis.renderer.grid.template.strokeOpacity = 0;
      dateAxis.startLocation = 1;
      dateAxis.endLocation = 0;
      dateAxis.tooltipDateFormat = '{date}';
      dateAxis.renderer.minGridDistance = 30;

      const valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.labels.template.disabled = true;
      valueAxis.renderer.grid.template.stroke = am4core.color('#213651');
      valueAxis.renderer.grid.template.strokeOpacity = 1;
      valueAxis.renderer.grid.template.strokeWidth = 2;
      valueAxis.strictMinMax = true;
      valueAxis.cursorTooltipEnabled = false;
      valueAxis.renderer.grid.template.disabled = true;
      valueAxis.renderer.labels.template.disabled = true;
      valueAxis.renderer.labels.template.fontSize = 12;
      valueAxis.renderer.labels.template.fontWeight = 500;
      // valueAxis.renderer.labels.template.color = am4core.color('#405069');

      const gradient = new am4core.LinearGradient();
      gradient.addColor(am4core.color('rgba(0, 102, 255, 0.16)'));
      gradient.addColor(am4core.color('rgba(0, 102, 255, 0))'));
      gradient.rotation = 90;

      const series = chart.series.push(new am4charts.LineSeries());
      series.dataFields.valueY = 'value';
      series.dataFields.dateX = 'date';
      series.stroke = am4core.color('#0066FF');
      series.tensionX = 0.8;
      series.strokeWidth = 2;
      series.fill = gradient;
      series.fillOpacity = 1;

      chart.cursor = new am4charts.XYCursor();
      chart.cursor.lineX.stroke = am4core.color('#595959');
      chart.cursor.lineX.strokeOpacity = 0;
      chart.cursor.lineX.strokeDasharray = '10';
      chart.cursor.lineY.stroke = am4core.color('#595959');
      chart.cursor.lineY.strokeOpacity = 0;
      chart.cursor.lineY.strokeDasharray = '10';
      chart.cursor.behavior = 'none';

      dateAxis.tooltip.disabled = true;

      // data ===================================

      let maxValue = 0;

      data.forEach((item) => {
        if (item.value > maxValue) maxValue = item.value;
      });

      valueAxis.renderer.baseGrid.disabled = true;

      valueAxis.min = -(maxValue / 4) ? -(maxValue / 3) : -1000;
      valueAxis.baseValue = -(maxValue / 4) ? -(maxValue / 3) : -1000;
      valueAxis.max = maxValue ? maxValue * 1.05 : 3000;

      const step = (valueAxis.max - valueAxis.min) / this.gridLinesCount;
      for (let i = 0; i < this.gridLinesCount; i++) {
        let range = valueAxis.axisRanges.create();
        range.value = valueAxis.min + i * step;
        range.label.disabled = true;
      }

      const chartData = [...data];
      const firstDate = new Date(chartData[0].date);
      firstDate.setDate(firstDate.getDate() - 1);
      const lastDate = new Date(chartData[chartData.length - 1].date);
      lastDate.setDate(lastDate.getDate() + 1);
      chartData.unshift({
        date: firstDate,
        value: chartData[0].value,
      });
      chartData.push({
        date: lastDate,
        value: chartData[chartData.length - 1].value,
      });

      const seriesTooltip = new am4core.Tooltip();
      series.tooltip = seriesTooltip;
      seriesTooltip.background.pointerLength = 6;
      seriesTooltip.background.pointerBaseWidth = 10;
      seriesTooltip.getFillFromObject = false;
      seriesTooltip.background.fill = am4core.color('#0C1521');
      seriesTooltip.background.fillOpacity = 1;
      seriesTooltip.background.strokeWidth = 0;
      seriesTooltip.background.cornerRadius = 6;
      seriesTooltip.label.fontSize = 12;
      seriesTooltip.label.fontWeight = 700;
      seriesTooltip.label.paddingTop = 7;
      seriesTooltip.label.paddingBottom = 6;
      seriesTooltip.label.paddingLeft = 12;
      seriesTooltip.label.paddingRight = 12;
      seriesTooltip.ignoreBounds = true;

      seriesTooltip.dy = -6;
      seriesTooltip.pointerOrientation = 'down';
      series.tooltipText = '{value} [#7587A3]{date}[/] ';
      seriesTooltip.background.filters.clear();

      const bullet = series.bullets.push(new am4core.Circle());
      bullet.radius = 5;
      bullet.fill = am4core.color('#0066FF');
      bullet.strokeWidth = 2;
      bullet.stroke = am4core.color('#132235');
      bullet.scale = 0;
      const hoverState = bullet.states.create('hover');
      hoverState.properties.scale = 1;

      chart.data = chartData;
    },
  },
};
</script>

<style lang="scss">
.the-chart {
  height: 172px;
}

g[transform='translate(0,151)'] {
  display: none;
}
</style>
